/* Stats - struct.h - Structure definitions
**
** CVS $Id: struct.h,v 1.1 2000/11/26 05:08:42 wcampbel Exp $
**
*/

#ifndef STRUCT_H
#define STRUCT_H

#include "stats.h"

/* Our data structures are recursive */
typedef struct server_ Server;
typedef struct user_ User;
typedef struct stats_ Stats;
typedef struct tld_ TLD;
typedef struct myuser_ MyUser;

/* This struct is getting out of hand...
** It needs to be split into at least a netinfo and
** a settings struct.  The remaining things will be 
** in the "catch all" me struct
*/
struct me {
	char name[MAXHOST];
	int port;
	int r_time;
	char uplink[MAXHOST];
	char vhost[MAXHOST];
	char pass[MAXPASS];
	char services_name[MAXHOST];
	char desc[LINE];
	time_t t_start;
	unsigned int enable_spam : 1;
	unsigned int want_privmsg : 1;
	unsigned int lag_notices : 1;
	unsigned int onlyopers : 1;
	unsigned int enable_html : 1;
	unsigned int set_oper : 1;
	unsigned int set_deaf : 1;
	unsigned int hide_services : 1;
	unsigned int flood_action : 1;
	unsigned int use_vhost : 1;
	int opers;
	int maxopers;
	int lag_time;
	long users;
	long maxusers;
	int servers;
	int maxservers;
	time_t t_maxopers;
	time_t t_maxusers;
	time_t t_maxservers;
	unsigned int away;
	Server *s;
	int requests;
	char html[BUFSIZE];
	int html_time;
	char html_link[BUFSIZE];
	char join_chans[BUFSIZE];
	char *chan_list[MAXCHANS];
	int chan_count;
	char url[BUFSIZE];
	int flood;
	int flood_time;
	char netname[MAXNICK];
	char admin_name[LINE];
	char admin_email[LINE];
} me;

struct StatServ {
	char user[MAXUSER];
	char host[MAXHOST];
} StatServ;

struct server_ {
	Server *next, *prev;
	char name[MAXHOST];
	char desc[LINE];
	int hops;
#ifdef IRCD_2_10
	int token;
#endif
	long hash;
	Stats *stats;
	unsigned int users;
	int opers;
	time_t connected_since;
	time_t last_announce;
	int ping;
	int lowest_ping;
	int highest_ping;
	time_t t_lowest_ping;
	time_t t_highest_ping;
	Server *uplink;
};

struct user_ {
	User *next, *prev;
	char nick[MAXNICK];
	char *hostname;
	char *username;
	Server *server;
	TLD *tld;
	MyUser *myuser;
	int flood;
	int flood_sent : 1;
	time_t t_flood;
	long hash;
	unsigned int is_oper : 1;
	unsigned int is_away : 1;
};

struct stats_ {
	Stats *next;
	char name[MAXHOST];
	int numsplits;
	long maxusers;
	time_t t_maxusers;
	int maxopers;
	time_t t_maxopers;
	time_t lastseen;
	time_t starttime;
	unsigned int operkills;
	unsigned int serverkills;
};

struct ping {
    time_t last_sent;
    int ulag;
} ping;

struct daily {
	int servers;
	time_t t_servers;
	int users;
	time_t t_users;
	int opers;
	time_t t_opers;
} daily;

struct tld_ {
	TLD *next;
	char tld[MAXTLD];
	char *country;
	int users;
};

struct myuser_ {
	MyUser *next;
	char *username;
	char *password;
	time_t lastseen;
	User *u;
	unsigned int ison : 1;
};

#endif
